import googlemaps

def get_lat_long(place):

    #Checking to make sure that the place is a string
    if str(type(place)) == "<class 'str'>":

        #Initializing google maps. NOTE: The API Key is not included for
        #security reasons. See README.txt for more information
        gmaps = googlemaps.Client(key='API_KEY')

        #Getting the geocode of the place
        geocode_result = gmaps.geocode(place)

        #If the resulting geocode is not empty, return the latitude, longitude
        #otherwise, return None for latitude and longitude
        if geocode_result:
            return(geocode_result[0]['geometry']['location'])
        else:
            return({'lat': None, 'lng': None})
