'''
2019-2020 Supercomputing Challenge
Project CO-OP
Team 66, Socorro High School
Cody Johnston
Elias Zheng
Lucas Ward
Rio Sessions
Teacher Sponsor: Jay Garcia
4/7/2020
'''

#NOTE: The code will not run without an API Key in the file Get_Places.py, and
#the upload section of the web map is password protected. If you would like
#to see results from running the model with different settings or data, contact
#Rio Sessions at 133348243@socorroschools.org or another team member from
#Socorro High School. We apologize for the inconvenience.


#Import tkinter for the GUI
import tkinter as tk

#Import the forecasting file to forecast input data
import Export_Crime_Prediction

#Import the officer placement file to place officers
import Export_Officer_Placement

#The function that runs when the submit button is pressed. This gets all input
#values and runs them through the officer placement
def submit():
    global city_text
    global qty_text
    global weigh_text
    global data_text
    global file_weigh_text
    global crime_out_text
    global police_out_text
    global max_text
    global grid_text

    print(city_text.get(),
          qty_text.get(),
          weigh_text.get(),
          data_text.get(),
          file_weigh_text.get(),
          crime_out_text.get(),
          police_out_text.get())

    root.destroy()

    Export_Crime_Prediction.export_prediction(city_text.get(),
                                              data_text.get(),
                                              int(weigh_text.get()),
                                              file_weigh_text.get(),
					      crime_out_text.get())
    
    Export_Officer_Placement.officer_placement(int(qty_text.get()),
                                               crime_out_text.get(),
                                               police_out_text.get(),
                                               grid_text.get(),
                                               max_text.get())


#Initializing the application window
root = tk.Tk()
root.title('Project CO-OP')

#Displaying the title
title = tk.Label(root, text='Project CO-OP Model', font=("Times", 18, 'bold'))
subtitle = tk.Label(root, text='Information Entry', font=("Times", 15))
title.pack()
subtitle.pack()

#The frame that holds the two text frames
holder = tk.Frame(root)
holder.pack()

#The variable text frame that includes all variables for users to input
var_title = tk.Label(holder, text='Variables', font=("Times", 13, 'bold'))
var_frame = tk.LabelFrame(holder, labelwidget=var_title)
var_frame.pack(side=tk.LEFT)

#The City entry variable
city_title = tk.Label(var_frame, text='City')
city_text = tk.StringVar(var_frame)
city_text.set("Albuquerque, NM")
city_entry = tk.Entry(var_frame, textvariable=city_text)
city_title.pack()
city_entry.pack()

#The Officer Count entry variable
qty_title = tk.Label(var_frame, text='\nOfficer Count')
qty_text = tk.StringVar(var_frame)
qty_text.set('100')
qty_entry = tk.Entry(var_frame, textvariable=qty_text)
qty_title.pack()
qty_entry.pack()

#The Default Weight entry variable
weigh_title = tk.Label(var_frame, text='\nDefault Weight')
weigh_text = tk.StringVar(var_frame)
weigh_text.set('50')
weigh_entry = tk.Entry(var_frame, textvariable=weigh_text)
weigh_title.pack()
weigh_entry.pack()

#The Grid Size entry variable
grid_title = tk.Label(var_frame, text='\nGrid Size')
grid_text = tk.StringVar(var_frame)
grid_text.set('1')
grid_entry = tk.Entry(var_frame, textvariable=grid_text)
grid_title.pack()
grid_entry.pack()

#The Max. # of officers per Grid entry variable
max_title = tk.Label(var_frame, text='\nMax. # of Officers per Grid\n(1-10)')
max_text = tk.StringVar(var_frame)
max_text.set('3')
max_entry = tk.Entry(var_frame, textvariable=max_text)
max_title.pack()
max_entry.pack()


#The text frame that holds the file entries
file_title = tk.Label(holder, text='Files', font=("Times", 13, 'bold'))
file_frame = tk.LabelFrame(holder, labelwidget=file_title)
file_frame.pack(side=tk.RIGHT)

#The data file entry variable
data_title = tk.Label(file_frame, text='Data File')
data_text = tk.StringVar(file_frame)
data_text.set('Previous_Data.txt')
data_entry = tk.Entry(file_frame, textvariable=data_text)
data_title.pack()
data_entry.pack()

#The Crime Weight File entry variable
file_weigh_title = tk.Label(file_frame, text='\nCrime Weight File')
file_weigh_text = tk.StringVar(file_frame)
file_weigh_text.set('weights.txt')
file_weigh_entry = tk.Entry(file_frame, textvariable=file_weigh_text)
file_weigh_title.pack()
file_weigh_entry.pack()

#The Predicted Ctime Output File entry variable
crime_out_title = tk.Label(file_frame, text='\nPredicted Crime Output File')
crime_out_text = tk.StringVar(file_frame)
crime_out_text.set('crimedata.txt')
crime_out_entry = tk.Entry(file_frame, textvariable=crime_out_text)
crime_out_title.pack()
crime_out_entry.pack()

#The Police Location Output File entry variable
police_out_title = tk.Label(file_frame, text='\nPolice Location Output File')
police_out_text = tk.StringVar(file_frame)
police_out_text.set('policedata.txt')
police_out_entry = tk.Entry(file_frame, textvariable=police_out_text)
police_out_title.pack()
police_out_entry.pack()

#The submit button
submit_entry = tk.Button(root, text="Submit", command=submit)
submit_entry.pack()

#Running the appication
root.mainloop()

